From: Debian Mono Group <pkg-mono-group@lists.alioth.debian.org>
Date: Sun, 6 Dec 2020 19:51:11 +0300
Subject: exclude-external-deps

===================================================================
---
 configure.ac                                       | 35 +++++++++++++++++-----
 m4/mono-output.m4                                  |  1 -
 mcs/Makefile                                       |  6 ++--
 mcs/build/executable.make                          |  8 +++++
 mcs/build/library.make                             | 13 ++++++++
 mcs/build/profiles/build.make                      |  4 +++
 mcs/build/rules.make                               |  7 ++++-
 mcs/class/Makefile                                 |  3 +-
 mcs/class/Mono.Directory.LDAP/Makefile             |  1 +
 mcs/class/Novell.Directory.Ldap/Makefile           |  1 +
 .../System.ComponentModel.Composition.4.5/Makefile |  1 +
 mcs/class/System.Data.Services.Client/Makefile     |  1 +
 mcs/class/System.Json.Microsoft/Makefile           |  1 +
 mcs/class/System.Net.Http.Formatting/Makefile      |  3 +-
 .../Makefile                                       |  1 +
 mcs/class/System.Web.Http.SelfHost/Makefile        |  3 +-
 mcs/class/System.Web.Http.WebHost/Makefile         |  1 +
 mcs/class/System.Web.Http/Makefile                 |  1 +
 mcs/class/System.Web.Mvc3/Makefile                 |  1 +
 mcs/class/System.Web.Razor/Makefile                |  1 +
 mcs/class/System.Web.WebPages.Deployment/Makefile  |  1 +
 mcs/class/System.Web.WebPages.Razor/Makefile       |  1 +
 mcs/class/System.Web.WebPages/Makefile             |  1 +
 mcs/class/System.Web/Makefile                      |  8 ++++-
 mcs/class/System.Windows.Forms/Makefile            |  1 +
 mcs/class/corlib/Makefile                          |  1 +
 mcs/class/corlib/il/Makefile                       |  1 +
 mcs/tools/Makefile                                 |  4 +--
 runtime/Makefile.am                                |  2 +-
 29 files changed, 92 insertions(+), 21 deletions(-)

diff --git a/configure.ac b/configure.ac
index 4d32c90..5635494 100644
--- a/configure.ac
+++ b/configure.ac
@@ -915,6 +915,17 @@ CFLAGS="$WARN $CFLAGS -g"
 CFLAGS_FOR_LIBGC="$CFLAGS_FOR_LIBGC -g"
 CPPFLAGS="$WARN $CPPFLAGS -g"
 
+AC_ARG_WITH(system-mono, [  --with-system-mono=path      Use installed Mono instead of included binaries], [], [with_system_mono=no])
+if test "x$with_system_mono" != xno; then
+        if test "x$with_system_mono" = xyes; then
+                system_mono_path=/usr/lib/mono
+        elif test "x$with_system_mono" != xno; then
+                system_mono_path=$with_system_mono
+        fi
+        AC_SUBST([system_mono_path])
+fi
+AM_CONDITIONAL(USE_SYSTEM_MONO, test "x$with_system_mono" != x)
+
 # Where's the 'mcs' source tree?
 if test -d $srcdir/mcs; then
   mcsdir=mcs
@@ -6098,8 +6109,17 @@ fi
 AC_SUBST(mono_runtime)
 AC_SUBST(mono_runtime_wrapper)
 
-CSC_LOCATION=`cd $srcdir && pwd`/external/roslyn-binaries/Microsoft.Net.Compilers/3.6.0/csc.exe
-VBCS_LOCATION=`cd $srcdir && pwd`/external/roslyn-binaries/Microsoft.Net.Compilers/3.6.0/VBCSCompiler.exe
+if test $csc_compiler = roslyn; then
+        if test x$with_system_mono = xno; then
+                CSC_LOCATION=`cd $srcdir && pwd`/external/roslyn-binaries/Microsoft.Net.Compilers/3.6.0/csc.exe
+                VBCS_LOCATION=`cd $srcdir && pwd`/external/roslyn-binaries/Microsoft.Net.Compilers/3.6.0/VBCSCompiler.exe
+        else
+                CSC_LOCATION=$system_mono_path/4.5/csc.exe
+                VBCS_LOCATION=$system_mono_path/4.5/VBCSCompiler.exe
+        fi
+        AC_CHECK_FILE([$CSC_LOCATION], [], [AC_MSG_ERROR([cound not find $CSC_LOCATION])])
+        AC_CHECK_FILE([$VBCS_LOCATION], [], [AC_MSG_ERROR([cound not find $VBCS_LOCATION])])
+fi
 
 if test $csc_compiler = mcs; then
   CSC=$mcs_topdir/class/lib/build/mcs.exe
@@ -6313,7 +6333,7 @@ else
 		mono_subdirs_ikvm_native=ikvm-native
 	fi
 
-	MONO_SUBDIRS="po $mono_subdirs_libgc llvm mono $mono_subdirs_ikvm_native $mono_subdirs_support data runtime scripts man samples $mono_subdirs_tools $mono_subdirs_docs msvc acceptance-tests"
+	MONO_SUBDIRS="po $mono_subdirs_libgc llvm mono $mono_subdirs_ikvm_native $mono_subdirs_support data runtime scripts man samples $mono_subdirs_tools $mono_subdirs_docs acceptance-tests"
 	MONO_NOINST_SUBDIRS="$mono_subdirs_libgc"
 fi
 
@@ -6753,11 +6773,6 @@ AC_SUBST(CPPFLAGS)
 AC_SUBST(LDFLAGS)
 AC_SUBST(ZLIB_CFLAGS)
 
-# Update all submodules recursively to ensure everything is checked out
-if test "x$with_core" != "xonly"; then
-	(cd $srcdir && scripts/update_submodules.sh)
-fi
-
 AC_MONO_OUTPUT()
 
 if test x$host_win32 = xyes; then
@@ -6796,6 +6811,10 @@ fi
     echo "sysconfdir=$sysconfdir" >> $mcs_topdir/build/config.make
     echo 'mono_libdir=${exec_prefix}/lib' >> $mcs_topdir/build/config.make
     echo "mono_build_root=$mono_build_root" >> $mcs_topdir/build/config.make
+    if test x$with_system_mono != xno; then
+      echo "USE_SYSTEM_MONO=true" >> $mcs_topdir/build/config.make
+      echo "system_mono_path=$system_mono_path" >> $mcs_topdir/build/config.make
+    fi
     echo "RUNTIME = $mono_build_root/runtime/mono-wrapper" >> $mcs_topdir/build/config.make
     echo "JAY_CFLAGS = $JAY_CFLAGS" >> $mcs_topdir/build/config.make
     echo "VERSION = $VERSION" >> $mcs_topdir/build/config.make
diff --git a/m4/mono-output.m4 b/m4/mono-output.m4
index c328bac..448b3c8 100644
--- a/m4/mono-output.m4
+++ b/m4/mono-output.m4
@@ -51,7 +51,6 @@ AC_DEFUN([AC_MONO_OUTPUT], [
 		mono/eglib/eglib-config.h
 		mono/eglib/test/Makefile
 		m4/Makefile
-		msvc/Makefile
 		mono/utils/jemalloc/Makefile
 		mono-uninstalled.pc
 		acceptance-tests/Makefile
diff --git a/mcs/Makefile b/mcs/Makefile
index 42c4496..0964453 100644
--- a/mcs/Makefile
+++ b/mcs/Makefile
@@ -1,6 +1,6 @@
 thisdir := .
 
-SUBDIRS := build jay mcs class ilasm tools tests errors docs packages
+SUBDIRS := build jay mcs class ilasm tools tests errors docs
 
 # Resgen is corlib specific tool
 
@@ -19,7 +19,7 @@ testing_aot_full_interp_SUBDIRS := build class
 testing_aot_hybrid_SUBDIRS := build class
 testing_aot_full_SUBDIRS := build class
 binary_reference_assemblies_SUBDIRS := build class
-net_4_x_SUBDIRS := build class ilasm tools tests errors docs mcs class/aot-compiler packages
+net_4_x_SUBDIRS := build class ilasm tools tests errors docs mcs class/aot-compiler
 xammac_net_4_5_SUBDIRS := build class
 xbuild_12_SUBDIRS := build class tools/xbuild
 xbuild_14_SUBDIRS := build class tools/xbuild
@@ -44,7 +44,7 @@ dir-check:
 
 # fun specialty targets
 
-PROFILES = net_4_x binary_reference_assemblies xbuild_12 xbuild_14
+PROFILES = net_4_x xbuild_12 xbuild_14
 
 .PHONY: all-profiles compiler-test-profiles run-compiler-test-profiles $(STD_TARGETS:=-profiles)
 all-profiles compiler-test-profiles run-compiler-test-profiles $(STD_TARGETS:=-profiles): %-profiles: profiles-do--%
diff --git a/mcs/build/executable.make b/mcs/build/executable.make
index 29abac5..44a246f 100644
--- a/mcs/build/executable.make
+++ b/mcs/build/executable.make
@@ -31,8 +31,12 @@ ifdef base_prog_config
 PROGRAM_config := $(build_libdir)$(PROGRAM).config
 endif
 
+ifdef USE_SYSTEM_MONO
+SN = sn -q
+else
 sn = $(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)/sn.exe
 SN = MONO_PATH="$(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) $(sn) -q
+endif
 
 the_lib = $(the_libdir)$(base_prog)
 build_lib = $(build_libdir)$(base_prog)
@@ -49,7 +53,11 @@ ifdef TARGET_NET_REFERENCE
 LIB_REFS_MONO = $(call _FILTER_OUT,System,$(call _FILTER_OUT,mscorlib,$(LIB_REFS_ALL)))
 LIB_REFS_SYSTEM = $(filter-out $(LIB_REFS_MONO),$(LIB_REFS_ALL))
 
+ifdef USE_SYSTEM_MONO
+MCS_REFERENCES = $(patsubst %,-r:$(system_mono_path)/$(subst v,,$(TARGET_NET_REFERENCE))-api/%.dll,$(LIB_REFS_SYSTEM))
+else
 MCS_REFERENCES = $(patsubst %,-r:$(topdir)/../external/binary-reference-assemblies/$(TARGET_NET_REFERENCE)/%.dll,$(LIB_REFS_SYSTEM))
+endif
 MCS_REFERENCES += $(patsubst %,-r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/%.dll,$(LIB_REFS_MONO))
 else
 MCS_REFERENCES = $(patsubst %,-r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/%.dll,$(LIB_REFS_ALL))
diff --git a/mcs/build/library.make b/mcs/build/library.make
index ca9b193..fb18aed 100644
--- a/mcs/build/library.make
+++ b/mcs/build/library.make
@@ -28,16 +28,25 @@ LIB_REFS_MONO_ALIAS = $(call _FILTER_OUT,System,$(LIB_REFS_ALIAS))
 LIB_REFS_NET_FULL = $(filter-out $(LIB_REFS_MONO_FULL),$(LIB_REFS_FULL))
 LIB_REFS_NET_ALIAS = $(filter-out $(LIB_REFS_MONO_ALIAS),$(LIB_REFS_ALIAS))
 
+ifdef USE_SYSTEM_MONO
+LIB_MCS_FLAGS += $(patsubst %,-r:$(system_mono_path)/$(subst v,,$(TARGET_NET_REFERENCE))-api/%.dll,$(LIB_REFS_NET_FULL))
+LIB_MCS_FLAGS += $(patsubst %,-r:%.dll, $(subst =,=$(system_mono_path)/$(subst v,,$(TARGET_NET_REFERENCE))-api/,$(LIB_REFS_NET_ALIAS)))
+else
 LIB_MCS_FLAGS += $(patsubst %,-r:$(topdir)/../external/binary-reference-assemblies/$(TARGET_NET_REFERENCE)/%.dll,$(LIB_REFS_NET_FULL))
 LIB_MCS_FLAGS += $(patsubst %,-r:%.dll, $(subst =,=$(topdir)/../external/binary-reference-assemblies/$(TARGET_NET_REFERENCE)/,$(LIB_REFS_NET_ALIAS)))
+endif
 
 LIB_MCS_FLAGS += $(patsubst %,-r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/%.dll,$(LIB_REFS_MONO_FULL))
 LIB_MCS_FLAGS += $(patsubst %,-r:%.dll, $(subst =,=$(topdir)/class/lib/$(PROFILE_DIRECTORY)/,$(LIB_REFS_MONO_ALIAS)))
 else
 
 ifdef API_BIN_REFS
+ifdef USE_SYSTEM_MONO
+LIB_MCS_FLAGS += $(patsubst %,-r:$(system_mono_path)/$(subst v,,$(API_BIN_PROFILE))-api/%.dll,$(API_BIN_REFS))
+else
 LIB_MCS_FLAGS += $(patsubst %,-r:$(topdir)/../external/binary-reference-assemblies/$(API_BIN_PROFILE)/%.dll,$(API_BIN_REFS))
 endif
+endif
 
 LIB_MCS_FLAGS += $(patsubst %,-r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/%.dll,$(LIB_REFS_FULL))
 LIB_MCS_FLAGS += $(patsubst %,-r:%.dll, $(subst =,=$(topdir)/class/lib/$(PROFILE_DIRECTORY)/,$(LIB_REFS_ALIAS)))
@@ -94,10 +103,14 @@ ifdef NO_SIGN_ASSEMBLY
 SN = :
 else
 ifeq ("$(SN)","")
+ifdef USE_SYSTEM_MONO
+SN = sn -q
+else
 sn = $(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)/sn.exe
 SN = MONO_PATH="$(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) $(sn) -q
 endif
 endif
+endif
 
 ifeq ($(BUILD_PLATFORM), win32)
 GACDIR = `cygpath -w $(mono_libdir)`
diff --git a/mcs/build/profiles/build.make b/mcs/build/profiles/build.make
index b1c9a41..d8f9836 100644
--- a/mcs/build/profiles/build.make
+++ b/mcs/build/profiles/build.make
@@ -30,7 +30,11 @@ endif
 # Special setup for boostrap tools which we want to run with system/monolite core libraries
 # for all libraries build as part of this profile
 #
+ifdef USE_SYSTEM_MONO
+ILASM = ilasm
+else
 ILASM = $(PROFILE_RUNTIME) $(RUNTIME_FLAGS) $(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)/tmp/ilasm.exe
+endif
 STRING_REPLACER = $(PROFILE_RUNTIME) $(RUNTIME_FLAGS) $(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)/tmp/cil-stringreplacer.exe
 GENSOURCES =$(PROFILE_RUNTIME) $(RUNTIME_FLAGS) $(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)/tmp/gensources.exe
 
diff --git a/mcs/build/rules.make b/mcs/build/rules.make
index e57a636..57bf278 100644
--- a/mcs/build/rules.make
+++ b/mcs/build/rules.make
@@ -57,9 +57,14 @@ INTERNAL_CSC_LOCATION = $(CSC_LOCATION)
 # Using CSC_SDK_PATH_DISABLED for sanity check that all references have path specified
 INTERNAL_CSC = CSC_SDK_PATH_DISABLED= $(RUNTIME) $(RUNTIME_FLAGS) $(CSC_RUNTIME_FLAGS) $(INTERNAL_CSC_LOCATION)
 
+ifdef USE_SYSTEM_MONO
+RESGEN = resgen
+ILASM = ilasm
+else
 RESGEN = MONO_PATH="$(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) $(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)/resgen.exe
-STRING_REPLACER = MONO_PATH="$(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) $(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)/cil-stringreplacer.exe
 ILASM = MONO_PATH="$(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) $(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)/ilasm.exe
+endif
+STRING_REPLACER = MONO_PATH="$(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) $(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)/cil-stringreplacer.exe
 GENSOURCES = MONO_PATH="$(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) $(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)/gensources.exe
 
 depsdir = $(topdir)/build/deps
diff --git a/mcs/class/Makefile b/mcs/class/Makefile
index 1ab7f8b..41fea7f 100644
--- a/mcs/class/Makefile
+++ b/mcs/class/Makefile
@@ -385,7 +385,6 @@ net_4_x_parallel_dirs = \
 	Mono.Profiler.Log	\
 	Mono.Runtime.Tests	\
 	System.Runtime.CompilerServices.Unsafe \
-	legacy/Mono.Cecil \
 	SystemWebTestShim \
 	$(xbuild_4_0_dirs)
 
@@ -460,7 +459,7 @@ include ../build/rules.make
 DIST_SUBDIRS = $(testing_aot_full_dirs_parallel) $(testing_aot_hybrid_dirs_parallel) $(monotouch_dirs_parallel) $(monotouch_tools_dirs_parallel) \
 $(monodroid_dirs_parallel) $(monodroid_tools_dirs_parallel) $(xammac_dirs_parallel) $(net_4_x_dirs) $(net_4_x_parallel_dirs) \
 $(xammac_4_5_dirs_parallel) $(unreal_dirs_parallel) $(wasm_dirs_parallel) $(wasm_tools_dirs_parallel) $(xbuild_14_SUBDIRS) \
-$(testing_aot_full_interp_dirs_parallel) $(netcore_SUBDIRS) dlr aot-compiler reference-assemblies Facades
+$(testing_aot_full_interp_dirs_parallel) $(netcore_SUBDIRS) dlr aot-compiler Facades
 
 # No new makefiles for: System.Messaging, System.Web.Mobile,
 # System.ServiceProcess
diff --git a/mcs/class/Mono.Directory.LDAP/Makefile b/mcs/class/Mono.Directory.LDAP/Makefile
index 040a180..f4e090a 100644
--- a/mcs/class/Mono.Directory.LDAP/Makefile
+++ b/mcs/class/Mono.Directory.LDAP/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/Mono.Directory.LDAP
 SUBDIRS = 
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = Mono.Directory.LDAP.dll
diff --git a/mcs/class/Novell.Directory.Ldap/Makefile b/mcs/class/Novell.Directory.Ldap/Makefile
index e7ffb40..9c63602 100644
--- a/mcs/class/Novell.Directory.Ldap/Makefile
+++ b/mcs/class/Novell.Directory.Ldap/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/Novell.Directory.Ldap
 SUBDIRS = 
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = Novell.Directory.Ldap.dll
diff --git a/mcs/class/System.ComponentModel.Composition.4.5/Makefile b/mcs/class/System.ComponentModel.Composition.4.5/Makefile
index 2b9e35c..1e6e857 100644
--- a/mcs/class/System.ComponentModel.Composition.4.5/Makefile
+++ b/mcs/class/System.ComponentModel.Composition.4.5/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/System.ComponentModel.Composition.4.5
 SUBDIRS = 
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = System.ComponentModel.Composition.dll
diff --git a/mcs/class/System.Data.Services.Client/Makefile b/mcs/class/System.Data.Services.Client/Makefile
index 73c724a..c5e3883 100644
--- a/mcs/class/System.Data.Services.Client/Makefile
+++ b/mcs/class/System.Data.Services.Client/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/System.Data.Services.Client
 SUBDIRS = 
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = System.Data.Services.Client.dll
diff --git a/mcs/class/System.Json.Microsoft/Makefile b/mcs/class/System.Json.Microsoft/Makefile
index 8938fa7..755d182 100644
--- a/mcs/class/System.Json.Microsoft/Makefile
+++ b/mcs/class/System.Json.Microsoft/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/System.Json.Microsoft
 SUBDIRS = 
+include ../../build/config.make
 include ../../build/rules.make
 
 RESOURCE_DEFS = System.Json.Properties.Resources,System.Json/Properties/Resources.resx
diff --git a/mcs/class/System.Net.Http.Formatting/Makefile b/mcs/class/System.Net.Http.Formatting/Makefile
index 43895c0..dbba87e 100644
--- a/mcs/class/System.Net.Http.Formatting/Makefile
+++ b/mcs/class/System.Net.Http.Formatting/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/System.Net.Http.Formatting
-SUBDIRS = 
+SUBDIRS =
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = System.Net.Http.Formatting.dll
diff --git a/mcs/class/System.Runtime.CompilerServices.Unsafe/Makefile b/mcs/class/System.Runtime.CompilerServices.Unsafe/Makefile
index 207310e..edbd959 100644
--- a/mcs/class/System.Runtime.CompilerServices.Unsafe/Makefile
+++ b/mcs/class/System.Runtime.CompilerServices.Unsafe/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/System.Runtime.CompilerServices.Unsafe
 SUBDIRS = 
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = System.Runtime.CompilerServices.Unsafe.dll
diff --git a/mcs/class/System.Web.Http.SelfHost/Makefile b/mcs/class/System.Web.Http.SelfHost/Makefile
index f4ff7d4..1b2422b 100644
--- a/mcs/class/System.Web.Http.SelfHost/Makefile
+++ b/mcs/class/System.Web.Http.SelfHost/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/System.Web.Http.SelfHost
-SUBDIRS = 
+SUBDIRS =
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = System.Web.Http.SelfHost.dll
diff --git a/mcs/class/System.Web.Http.WebHost/Makefile b/mcs/class/System.Web.Http.WebHost/Makefile
index b022ea3..dc1c71c 100644
--- a/mcs/class/System.Web.Http.WebHost/Makefile
+++ b/mcs/class/System.Web.Http.WebHost/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/System.Web.Http.WebHost
 SUBDIRS = 
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = System.Web.Http.WebHost.dll
diff --git a/mcs/class/System.Web.Http/Makefile b/mcs/class/System.Web.Http/Makefile
index 22be825..d8702d2 100644
--- a/mcs/class/System.Web.Http/Makefile
+++ b/mcs/class/System.Web.Http/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/System.Web.Http
 SUBDIRS = 
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = System.Web.Http.dll
diff --git a/mcs/class/System.Web.Mvc3/Makefile b/mcs/class/System.Web.Mvc3/Makefile
index 20b0edc..8f6df4d 100644
--- a/mcs/class/System.Web.Mvc3/Makefile
+++ b/mcs/class/System.Web.Mvc3/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/System.Web.Mvc3
 SUBDIRS = 
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = System.Web.Mvc3.dll
diff --git a/mcs/class/System.Web.Razor/Makefile b/mcs/class/System.Web.Razor/Makefile
index c329613..008a5b0 100644
--- a/mcs/class/System.Web.Razor/Makefile
+++ b/mcs/class/System.Web.Razor/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/System.Web.Razor
 SUBDIRS = 
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = System.Web.Razor.dll
diff --git a/mcs/class/System.Web.WebPages.Deployment/Makefile b/mcs/class/System.Web.WebPages.Deployment/Makefile
index bb1cd40..ed56670 100644
--- a/mcs/class/System.Web.WebPages.Deployment/Makefile
+++ b/mcs/class/System.Web.WebPages.Deployment/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/System.Web.WebPages.Deployment
 SUBDIRS = 
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = System.Web.WebPages.Deployment.dll
diff --git a/mcs/class/System.Web.WebPages.Razor/Makefile b/mcs/class/System.Web.WebPages.Razor/Makefile
index b9f7f8f..08b94c9 100644
--- a/mcs/class/System.Web.WebPages.Razor/Makefile
+++ b/mcs/class/System.Web.WebPages.Razor/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/System.Web.WebPages.Razor
 SUBDIRS = 
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = System.Web.WebPages.Razor.dll
diff --git a/mcs/class/System.Web.WebPages/Makefile b/mcs/class/System.Web.WebPages/Makefile
index 91e1581..081cb2c 100644
--- a/mcs/class/System.Web.WebPages/Makefile
+++ b/mcs/class/System.Web.WebPages/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/System.Web.WebPages
 SUBDIRS = 
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = System.Web.WebPages.dll
diff --git a/mcs/class/System.Web/Makefile b/mcs/class/System.Web/Makefile
index 375c3f0..96481cd 100644
--- a/mcs/class/System.Web/Makefile
+++ b/mcs/class/System.Web/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/System.Web
 SUBDIRS = Test
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = System.Web.dll
@@ -352,6 +353,11 @@ endif
 ifdef STANDALONE_VERBOSE
 RUN_STANDALONE += --verbose
 endif
+ifdef USE_SYSTEM_MONO
+culevel = $(system_mono_path)/4.5/culevel.exe
+else
+culevel = $(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)/culevel.exe
+endif
 
 $(build_lib): $(RESX_RES) $(RESOURCE_FILES_2) $(RESOURCE_FILES_1)
 
@@ -359,7 +365,7 @@ $(RESX_RES): %.resources: %.resx
 	$(RESGEN) `echo $< | $(PLATFORM_CHANGE_SEPARATOR_CMD)`
 
 System.Web/UplevelHelper.cs: UplevelHelperDefinitions.xml
-	MONO_PATH="$(topdir)/class/lib/$(BOOTSTRAP_PROFILE)$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) $(topdir)/class/lib/$(BUILD_TOOLS_PROFILE)/culevel.exe -o $@ $^
+	MONO_PATH="$(topdir)/class/lib/$(BOOTSTRAP_PROFILE)$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" $(RUNTIME) $(RUNTIME_FLAGS) $(culevel) -o $@ $^
 
 run-aaa: test
 	$(TEST_RUNTIME) $(TEST_RUNTIME_FLAGS) $(TEST_HARNESS) $(TEST_HARNESS_FLAGS) $(LOCAL_TEST_HARNESS_FLAGS) \
diff --git a/mcs/class/System.Windows.Forms/Makefile b/mcs/class/System.Windows.Forms/Makefile
index 8877bcc..88fd75f 100644
--- a/mcs/class/System.Windows.Forms/Makefile
+++ b/mcs/class/System.Windows.Forms/Makefile
@@ -1,4 +1,5 @@
 thisdir = class/System.Windows.Forms
+include ../../build/config.make
 include ../../build/rules.make
 
 LIBRARY = System.Windows.Forms.dll
diff --git a/mcs/class/corlib/Makefile b/mcs/class/corlib/Makefile
index e399631..c3fe92e 100644
--- a/mcs/class/corlib/Makefile
+++ b/mcs/class/corlib/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/corlib
 SUBDIRS =
+include ../../build/config.make
 include ../../build/rules.make
 export __SECURITY_BOOTSTRAP_DB=$(topdir)/class/corlib
 
diff --git a/mcs/class/corlib/il/Makefile b/mcs/class/corlib/il/Makefile
index 8493711..01970a4 100644
--- a/mcs/class/corlib/il/Makefile
+++ b/mcs/class/corlib/il/Makefile
@@ -1,5 +1,6 @@
 thisdir = class/corlib/il
 
+include ../../../build/config.make
 include ../../../build/rules.make
 include il.make
 
diff --git a/mcs/tools/Makefile b/mcs/tools/Makefile
index f774b6f..8818379 100644
--- a/mcs/tools/Makefile
+++ b/mcs/tools/Makefile
@@ -52,7 +52,7 @@ net_4_5_dirs := \
 	gacutil
 
 build_SUBDIRS =
-build_PARALLEL_SUBDIRS := resgen gacutil security culevel upload-to-sentry mono-helix-client commoncryptogenerator resx2sr linker cil-strip corcompare mono-api-diff mono-api-html
+build_PARALLEL_SUBDIRS := resgen gacutil security culevel upload-to-sentry commoncryptogenerator resx2sr linker cil-strip corcompare mono-api-diff mono-api-html
 monodroid_tools_SUBDIRS =
 monodroid_tools_PARALLEL_SUBDIRS = aprofutil cil-strip linker-analyzer mkbundle mdoc mono-symbolicate corcompare mono-api-diff mono-api-html pdb2mdb nunit-lite
 monodroid_SUBDIRS = nunit-lite
@@ -68,7 +68,7 @@ net_4_x_PARALLEL_SUBDIRS = $(net_4_5_dirs)
 wasm_tools_SUBDIRS =
 wasm_tools_PARALLEL_SUBDIRS = linker wasm-tuner cil-strip
 
-DIST_SUBDIRS = $(net_4_5_dirs) cil-stringreplacer commoncryptogenerator resx2sr gensources upload-to-sentry mono-helix-client
+DIST_SUBDIRS = $(net_4_5_dirs) cil-stringreplacer commoncryptogenerator resx2sr gensources upload-to-sentry
 
 include ../build/rules.make
 
diff --git a/runtime/Makefile.am b/runtime/Makefile.am
index 9e29cb5..b0bf0e7 100644
--- a/runtime/Makefile.am
+++ b/runtime/Makefile.am
@@ -34,7 +34,7 @@ SUPPORT_FILES = $(symlinks) mono-wrapper etc/mono/config
 build_profiles = 
 
 if INSTALL_4_x
-build_profiles += binary_reference_assemblies net_4_x xbuild_12 xbuild_14
+build_profiles += net_4_x xbuild_12 xbuild_14
 net_profile = net_4_x
 endif
 
